Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JOptionPane

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JOptionPane

public class JOptionPane
extends JComponent
implements Accessible

JOptionPane makes it easy to pop up a standard dialog box that prompts users for a value or informs them of something. While the class may appear complex because of the large number of methods, almost all uses of this class are one-line calls to one of the static `showXxxDialog` methods shown below:

> showConfirmDialog | Asks a confirming question, like yes/no/cancel.
> showInputDialog | Prompt for some input.
> showMessageDialog | Tell the user about something that has happened.
> showOptionDialog | The Grand Unification of the above three.

Each of these methods also comes in a `showInternalXXX` flavor, which uses an internal frame to hold the dialog box (see `JInternalFrame`). Multiple convenience methods have also been defined -- overloaded versions of the basic methods that use different parameter lists.

All dialogs are modal. Each `showXxxDialog` method blocks the current thread until the user's interaction is complete.

icon | message
input value
option buttons

The basic appearance of one of these dialog boxes is generally similar to the picture at the right, although the various look-and-feels are ultimatly responsible for the final result.

Parameters:
The parameters to these methods follow consistent patterns:

> parentComponent
>   Defines the Component that is to be the parent of this dialog box. It is used in two ways: the Frame that contains it is used as the Frame parent for the dialog box, and its screen coordinates are used in the placement of the dialog box. In general, the dialog box is placed just below the component. This parameter may be null, in which case a default Frame is used as the parent, and the dialog will be centered on the screen (depending on the L&F).
> message
>   A descriptive message to be placed in the dialog box. In the most common usage, message is just a String or String constant. However, the type of this parameter is actually Object. It's interpretation depends on its type:
>   Object[]
>     An array of objects is interpreted as a series of messages (one per object) arranged in a vertical stack. The interpretation is recursive -- each object in the array is interpreted according to its type.
>   Component
>     The Component is displayed in the dialog.
>   Icon
>     The Icon is wrapped in a JLabel and displayed in the dialog.
>   others
>     The object is converted to a String by calling its `toString` method. The result is wrapped in a JLabel and displayed.
> messageType
>   Defines the style of the message. The look&feel manager may lay out the dialog differently depending on this value, and will often provide a default icon. The possible values are:
>   - ERROR_MESSAGE
>   - INFORMATION_MESSAGE
>   - WARNING_MESSAGE
>   - QUESTION_MESSAGE
>   - PLAIN_MESSAGE
> optionType
>   Defines the set of option buttons that appear at the bottom of the dialog box:
>   - DEFAULT_OPTION
>   - YES_NO_OPTION
>   - YES_NO_CANCEL_OPTION
>   - OK_CANCEL_OPTION
>   You aren't limited to this set of option buttons. You can provide any buttons you want using the options parameter.
> options
>   A more detailed description of the set of option buttons that will appear at the bottom of the dialog box. The usual value for the options parameter is an array of Strings. But the parameter type is an array of Objects. A button is created for each object depending on it's type:
>   Component
>     The component is added to the button row directly.
>   Icon
>     A JButton is created with this as its label.
>   other
>     The Object is converted to a string using its `toString` method and the result is used to label a JButton.
> icon
>   A decorative icon to be placed in the dialog box. A default value for this is determined by the messageType parameter.
> title
>   The title for the dialog box.
> initialValue
>   The default selection (input value).

When the selection is changed, `setValue` is invoked, which generates a PropertyChangeEvent.

If a JOptionPane has configured to all input `setWantsInput` the bound property JOptionPane.INPUT_VALUE_PROPERTY can also be listened to, to determine when the user has input or selected a value.

When one of the `showXxxDialog` methods returns an integer, the possible values are:

         YES_OPTION,
         NO_OPTION,
         CANCEL_OPTION,
         OK_OPTION, or
         CLOSED_OPTION.

Examples:

Show an error dialog that displays the message, 'alert':
  `JOptionPane.showMessageDialog(null, "alert", "alert", ERROR_MESSAGE);`

Show an internal information dialog with the message, 'information':
  `JOptionPane.showInternalMessageDialog(frame, INFORMATION_MESSAGE,
  "information", "information");
  `

Show an information panel with the options yes/no and message 'choose one':
  `JOptionPane.showConfirmDialog(null,
  "choose one", "choose one", YES_NO_OPTION);
  `

Show an internal information dialog with the options yes/no/cancel and message 'please choose one' and title information:
  `JOptionPane.showInternalConfirmDialog(frame,
  "please choose one", "information",
  YES_NO_CANCEL_OPTION, INFORMATION_MESSAGE);
  `

Show a warning dialog with the options OK, CANCEL, title 'Warning', and message 'Click OK to continue':
  `Object[] options = { "OK", "CANCEL" };
  JOptionPane.showOptionDialog(null, "Click OK to continue", "Warning",
  DEFAULT_OPTION, WARNING_MESSAGE,
  null, options, options[0]);
  `

Show a dialog asking the user to type in a String:
  `String inputValue = JOptionPane.showInputDialog("Please input a value");`

Show a dialog asking the user to select a String:
  `Object[] possibleValues = { "First", "Second", "Third" };
  Object selectedValue = JOptionPane.showInputDialog(null,
  "Choose one", "Input",
  JOptionPane.INFORMATION_MESSAGE, null,
  possibleValues, possibleValues[0]);
  `

Direct Use:
To create and use an JOptionPane directly, the standard pattern is roughly as follows:

         JOptionPane pane = new JOptionPane(arguments);
         pane.set.Xxxx(...); // Configure
         JDialog dialog = pane.createDialog(parentComponent, title);
         dialog.show();
         Object selectedValue = pane.getValue();
         if(selectedValue == null)
           return CLOSED_OPTION;
         //If there is not an array of option buttons:
         if(options == null) {
           if(selectedValue instanceof Integer)
              return ((Integer)selectedValue).intValue();
           return CLOSED_OPTION;
         }
         //If there is an array of option buttons:
         for(int counter = 0, maxCounter = options.length;
            counter < maxCounter; counter++) {
            if(options[counter].equals(selectedValue))
            return counter;
         }
         return CLOSED_OPTION;

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JOptionPane key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `JInternalFrame`, Serialized Form

Inner Class Summary
`protected class` | `JOptionPane.AccessibleJOptionPane` Accessiblity support.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Field Summary
`static int` | `CANCEL_OPTION` Return value from class method if CANCEL is chosen.
`static int` | `CLOSED_OPTION` Return value from class method if user closes window without selecting anything, more than likely this should be treated as either a CANCEL_OPTION or NO_OPTION.
`static int` | `DEFAULT_OPTION` Type meaning look and feel should not supply any options -- only use the options from the JOptionPane.
`static int` | `ERROR_MESSAGE` Used for error messages.
`protected Icon` | `icon` Icon used in pane.
`static java.lang.String` | `ICON_PROPERTY` Bound property name for icon.
`static int` | `INFORMATION_MESSAGE` Used for information messages.
`static java.lang.String` | `INITIAL_SELECTION_VALUE_PROPERTY` Bound property name for initialSelectionValue.
`static java.lang.String` | `INITIAL_VALUE_PROPERTY` Bounds property name for initialValue.
`protected java.lang.Object` | `initialSelectionValue` Initial value to select in selectionValues.
`protected java.lang.Object` | `initialValue` Value that should be initialy selected in options.
`static java.lang.String` | `INPUT_VALUE_PROPERTY` Bound property name for inputValue.
`protected java.lang.Object` | `inputValue` Value the user has input.
`protected java.lang.Object` | `message` Message to display.
`static java.lang.String` | `MESSAGE_PROPERTY` Bound property name for message.
`static java.lang.String` | `MESSAGE_TYPE_PROPERTY` Bounds property name for type.
`protected int` | `messageType` Message type.
`static int` | `NO_OPTION` Return value from class method if NO is chosen.
`static int` | `OK_CANCEL_OPTION` Type used for showConfirmDialog.
`static int` | `OK_OPTION` Return value form class method if OK is chosen.
`static java.lang.String` | `OPTION_TYPE_PROPERTY` Bound property name for optionType.
`protected java.lang.Object[]` | `options` Options to display to the user.
`static java.lang.String` | `OPTIONS_PROPERTY` Bounds property namer for option.
`protected int` | `optionType` Option type, one of DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION or OK_CANCEL_OPTION.
`static int` | `PLAIN_MESSAGE` No icon is used.
`static int` | `QUESTION_MESSAGE` Used for questions.
`static java.lang.String` | `SELECTION_VALUES_PROPERTY` Bound property name for selectionValues.
`protected java.lang.Object[]` | `selectionValues` Array of values the user can choose from.
`static java.lang.Object` | `UNINITIALIZED_VALUE` Indicates that the user has not yet selected a value.
`protected java.lang.Object` | `value` Currently selected value, will be a valid option, or UNINITIALIZED_VALUE or null.
`static java.lang.String` | `VALUE_PROPERTY` Bounds property name for value.
`static java.lang.String` | `WANTS_INPUT_PROPERTY` Bound property name for wantsInput.
`protected boolean` | `wantsInput` If true, a UI widget will be provided to the user to get input.
`static int` | `WARNING_MESSAGE` Used for warning messages.
`static int` | `YES_NO_CANCEL_OPTION` Type used for showConfirmDialog.
`static int` | `YES_NO_OPTION` Type used for showConfirmDialog.
`static int` | `YES_OPTION` Return value from class method if YES is chosen.

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JOptionPane()` Creates a JOptionPane with a test message.
`JOptionPane(java.lang.Object message)` Creates a instance of JOptionPane to display a message using the plain-message message type and the default options delivered by the UI.
`JOptionPane(java.lang.Object message, int messageType)` Creates an instance of JOptionPane to display a message with the specified message type and the default options,
`JOptionPane(java.lang.Object message, int messageType, int optionType)` Creates an instance of JOptionPane to display a message with the specified message type and options.
`JOptionPane(java.lang.Object message, int messageType, int optionType, Icon icon)` Creates an instance of JOptionPane to display a message with the specified message type, options, and icon.
`JOptionPane(java.lang.Object message, int messageType, int optionType, Icon icon, java.lang.Object[] options)` Creates an instance of JOptionPane to display a message with the specified message type, icon, and options.
`JOptionPane(java.lang.Object message, int messageType, int optionType, Icon icon, java.lang.Object[] options, java.lang.Object initialValue)` Creates an instance of JOptionPane to display a message with the specified message type, icon, and options, with the inititially-selected option specified.

Method Summary
`JDialog` | `createDialog(java.awt.Component parentComponent, java.lang.String title)` Creates and returns a new JDialog wrapping `this` centered on the `parentComponent` in the `parentComponent`'s frame.
`JInternalFrame` | `createInternalFrame(java.awt.Component parentComponent, java.lang.String title)` Creates and returns an instance of JInternalFrame.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JComponent
`static JDesktopPane` | `getDesktopPaneForComponent(java.awt.Component parentComponent)` Returns the specified component's desktop pane.
`static java.awt.Frame` | `getFrameForComponent(java.awt.Component parentComponent)` Returns the specified component's Frame.
`Icon` | `getIcon()` Returns the icon this pane displays.
`java.lang.Object` | `getInitialSelectionValue()` Returns the initial-selection value..
`java.lang.Object` | `getInitialValue()` Returns the initial value.
`java.lang.Object` | `getInputValue()` Returns the value the user has input, if `wantsInput` is true.
`int` | `getMaxCharactersPerLineCount()` Returns the maximum number of characters to place on a line in a message.
`java.lang.Object` | `getMessage()` Returns the message-object this pane displays.
`int` | `getMessageType()` Returns the message type.
`java.lang.Object[]` | `getOptions()` Returns the choices the user can make.
`int` | `getOptionType()` Returns the type of options that are displayed.
`static java.awt.Frame` | `getRootFrame()` Returns the Frame to use for the class methods in which a frame is not provided.
`java.lang.Object[]` | `getSelectionValues()` Returns the selection values.
`OptionPaneUI` | `getUI()` Returns the UI object which implements the L&F for this component.
`java.lang.String` | `getUIClassID()` Returns the name of the UI class that implements the L&F for this component.
`java.lang.Object` | `getValue()` Returns the value the user has selected.
`boolean` | `getWantsInput()` Returns true if a parentComponent will be provided for the user to input.
`protected java.lang.String` | `paramString()` Returns a string representation of this JOptionPane.
`void` | `selectInitialValue()` Requests that the initial value be selected, which will set focus to the initial value.
`void` | `setIcon(Icon newIcon)` Sets the icon to display.
`void` | `setInitialSelectionValue(java.lang.Object newValue)` Sets the initial selection value.
`void` | `setInitialValue(java.lang.Object newInitialValue)` Sets the initial value that is to be enabled -- the Component that has the focus when the pane is initially displayed.
`void` | `setInputValue(java.lang.Object newValue)` Sets the user's input-value.
`void` | `setMessage(java.lang.Object newMessage)` Sets the option pane's message-object.
`void` | `setMessageType(int newType)` Sets the option pane's message type.
`void` | `setOptions(java.lang.Object[] newOptions)` Sets the options this pane displays.
`void` | `setOptionType(int newType)` Sets the options to display.
`static void` | `setRootFrame(java.awt.Frame newRootFrame)` Sets the frame to use for class methods in which a frame is not provided.
`void` | `setSelectionValues(java.lang.Object[] newValues)` Sets the selection values for a pane that provides the user with a list of items to choose from.
`void` | `setUI(OptionPaneUI ui)` Sets the UI object which implements the L&F for this component.
`void` | `setValue(java.lang.Object newValue)` Sets the value the user has chosen.
`void` | `setWantsInput(boolean newValue)` If `newValue` is true, a parentComponent is provided to allow the user to input a value.
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message)` Brings up a modal dialog with the options Yes, No and Cancel; with the title, "Select an Option".
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType)` Brings up a modal dialog where the number of choices is determined by the `optionType` parameter.
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType)` Brings up a modal dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, Icon icon)` Brings up a modal dialog with a specified icon, where the number of choices is determined by the `optionType` parameter.
`static java.lang.String` | `showInputDialog(java.awt.Component parentComponent, java.lang.Object message)` Shows a question-message dialog requesting input from the user parented to `parentComponent`.
`static java.lang.String` | `showInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
`static java.lang.Object` | `showInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, Icon icon, java.lang.Object[] selectionValues, java.lang.Object initialSelectionValue)` Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified.
`static java.lang.String` | `showInputDialog(java.lang.Object message)` Shows a question-message dialog requesting input from the user.
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message)` Brings up an internal dialog panel with the options Yes, No and Cancel; with the title, "Select an Option".
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType)` Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType)` Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, Icon icon)` Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter.
`static java.lang.String` | `showInternalInputDialog(java.awt.Component parentComponent, java.lang.Object message)` Shows an internal question-message dialog requesting input from the user parented to `parentComponent`.
`static java.lang.String` | `showInternalInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
`static java.lang.Object` | `showInternalInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, Icon icon, java.lang.Object[] selectionValues, java.lang.Object initialSelectionValue)` Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified.
`static void` | `showInternalMessageDialog(java.awt.Component parentComponent, java.lang.Object message)` Brings up an internal confirmation dialog panel.
`static void` | `showInternalMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Brings up an internal dialog panel that displays a message using a default icon determined by the messageType parameter.
`static void` | `showInternalMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, Icon icon)` Brings up an internal dialog panel displaying a message, specifying all parameters.
`static int` | `showInternalOptionDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, Icon icon, java.lang.Object[] options, java.lang.Object initialValue)` Brings up an internal dialog panel with a specified icon, where the initial choice is dermined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.
`static void` | `showMessageDialog(java.awt.Component parentComponent, java.lang.Object message)` Brings up a confirmation dialog -- a modal information-message dialog titled "Confirm".
`static void` | `showMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Brings up a dialog that displays a message using a default icon determined by the messageType parameter.
`static void` | `showMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, Icon icon)` Brings up a dialog displaying a message, specifying all parameters.
`static int` | `showOptionDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, Icon icon, java.lang.Object[] options, java.lang.Object initialValue)` Brings up a modal dialog with a specified icon, where the initial choice is dermined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.
`void` | `updateUI()` Notification from the UIManager that the L&F has changed.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processComponentKeyEvent, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### UNINITIALIZED_VALUE

    public static final java.lang.Object UNINITIALIZED_VALUE

  Indicates that the user has not yet selected a value.

### DEFAULT_OPTION

    public static final int DEFAULT_OPTION

  Type meaning look and feel should not supply any options -- only use the options from the JOptionPane.

### YES_NO_OPTION

    public static final int YES_NO_OPTION

  Type used for showConfirmDialog.

### YES_NO_CANCEL_OPTION

    public static final int YES_NO_CANCEL_OPTION

  Type used for showConfirmDialog.

### OK_CANCEL_OPTION

    public static final int OK_CANCEL_OPTION

  Type used for showConfirmDialog.

### YES_OPTION

    public static final int YES_OPTION

  Return value from class method if YES is chosen.

### NO_OPTION

    public static final int NO_OPTION

  Return value from class method if NO is chosen.

### CANCEL_OPTION

    public static final int CANCEL_OPTION

  Return value from class method if CANCEL is chosen.

### OK_OPTION

    public static final int OK_OPTION

  Return value form class method if OK is chosen.

### CLOSED_OPTION

    public static final int CLOSED_OPTION

  Return value from class method if user closes window without selecting anything, more than likely this should be treated as either a CANCEL_OPTION or NO_OPTION.

### ERROR_MESSAGE

    public static final int ERROR_MESSAGE

  Used for error messages.

### INFORMATION_MESSAGE

    public static final int INFORMATION_MESSAGE

  Used for information messages.

### WARNING_MESSAGE

    public static final int WARNING_MESSAGE

  Used for warning messages.

### QUESTION_MESSAGE

    public static final int QUESTION_MESSAGE

  Used for questions.

### PLAIN_MESSAGE

    public static final int PLAIN_MESSAGE

  No icon is used.

### ICON_PROPERTY

    public static final java.lang.String ICON_PROPERTY

  Bound property name for icon.

### MESSAGE_PROPERTY

    public static final java.lang.String MESSAGE_PROPERTY

  Bound property name for message.

### VALUE_PROPERTY

    public static final java.lang.String VALUE_PROPERTY

  Bounds property name for value.

### OPTIONS_PROPERTY

    public static final java.lang.String OPTIONS_PROPERTY

  Bounds property namer for option.

### INITIAL_VALUE_PROPERTY

    public static final java.lang.String INITIAL_VALUE_PROPERTY

  Bounds property name for initialValue.

### MESSAGE_TYPE_PROPERTY

    public static final java.lang.String MESSAGE_TYPE_PROPERTY

  Bounds property name for type.

### OPTION_TYPE_PROPERTY

    public static final java.lang.String OPTION_TYPE_PROPERTY

  Bound property name for optionType.

### SELECTION_VALUES_PROPERTY

    public static final java.lang.String SELECTION_VALUES_PROPERTY

  Bound property name for selectionValues.

### INITIAL_SELECTION_VALUE_PROPERTY

    public static final java.lang.String INITIAL_SELECTION_VALUE_PROPERTY

  Bound property name for initialSelectionValue.

### INPUT_VALUE_PROPERTY

    public static final java.lang.String INPUT_VALUE_PROPERTY

  Bound property name for inputValue.

### WANTS_INPUT_PROPERTY

    public static final java.lang.String WANTS_INPUT_PROPERTY

  Bound property name for wantsInput.

### icon

    protected transient Icon icon

  Icon used in pane.

### message

    protected transient java.lang.Object message

  Message to display.

### options

    protected transient java.lang.Object[] options

  Options to display to the user.

### initialValue

    protected transient java.lang.Object initialValue

  Value that should be initialy selected in options.

### messageType

    protected int messageType

  Message type.

### optionType

    protected int optionType

  Option type, one of DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION or OK_CANCEL_OPTION.

### value

    protected transient java.lang.Object value

  Currently selected value, will be a valid option, or UNINITIALIZED_VALUE or null.

### selectionValues

    protected transient java.lang.Object[] selectionValues

  Array of values the user can choose from. Look and feel will provide the UI component to choose this from.

### inputValue

    protected transient java.lang.Object inputValue

  Value the user has input.

### initialSelectionValue

    protected transient java.lang.Object initialSelectionValue

  Initial value to select in selectionValues.

### wantsInput

    protected boolean wantsInput

  If true, a UI widget will be provided to the user to get input.

Constructor Detail

### JOptionPane

    public JOptionPane()

  Creates a JOptionPane with a test message.

### JOptionPane

    public JOptionPane(java.lang.Object message)

  Creates a instance of JOptionPane to display a message using the plain-message message type and the default options delivered by the UI.
  Parameters:
    `message` - the Object to display

### JOptionPane

    public JOptionPane(java.lang.Object message,
                       int messageType)

  Creates an instance of JOptionPane to display a message with the specified message type and the default options,
  Parameters:
    `message` - the Object to display
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.

### JOptionPane

    public JOptionPane(java.lang.Object message,
                       int messageType,
                       int optionType)

  Creates an instance of JOptionPane to display a message with the specified message type and options.
  Parameters:
    `message` - the Object to display
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `optionType` - the options to display in the pane: DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION OK_CANCEL_OPTION

### JOptionPane

    public JOptionPane(java.lang.Object message,
                       int messageType,
                       int optionType,
                       Icon icon)

  Creates an instance of JOptionPane to display a message with the specified message type, options, and icon.
  Parameters:
    `message` - the Object to display
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `optionType` - the options to display in the pane: DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION OK_CANCEL_OPTION
    `icon` - the Icon image to display

### JOptionPane

    public JOptionPane(java.lang.Object message,
                       int messageType,
                       int optionType,
                       Icon icon,
                       java.lang.Object[] options)

  Creates an instance of JOptionPane to display a message with the specified message type, icon, and options. None of the options is initially selected.

  The options objects should contain either instances of Components, (which are added directly) or Strings (which are wrapped in a JButton). If you provide Components, you must ensure that when the Component is clicked it messages `setValue` in the created JOptionPane.

  Parameters:
    `message` - the Object to display
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `optionType` - the options to display in the pane: DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION OK_CANCEL_OPTION. Only meaningful if the `options` parameter is null.
    `icon` - the Icon image to display
    `options` - the choices the user can select

### JOptionPane

    public JOptionPane(java.lang.Object message,
                       int messageType,
                       int optionType,
                       Icon icon,
                       java.lang.Object[] options,
                       java.lang.Object initialValue)

  Creates an instance of JOptionPane to display a message with the specified message type, icon, and options, with the inititially-selected option specified.
  Parameters:
    `message` - the Object to display
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `optionType` - the options to display in the pane: DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION OK_CANCEL_OPTION. Only meaningful if the `options` parameter is null.
    `icon` - the Icon image to display
    `options` - the choices the user can select
    `initialValue` - the choice that is initially selected

Method Detail

### showInputDialog

    public static java.lang.String showInputDialog(java.lang.Object message)

  Shows a question-message dialog requesting input from the user. The dialog uses the default frame, which usually means it is centered on the screen.
  Parameters:
    `message` - the Object to display

### showInputDialog

    public static java.lang.String showInputDialog(java.awt.Component parentComponent,
                                                   java.lang.Object message)

  Shows a question-message dialog requesting input from the user parented to `parentComponent`. The dialog is displayed in the Component's frame, and is usually positioned below the Component.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display

### showInputDialog

    public static java.lang.String showInputDialog(java.awt.Component parentComponent,
                                                   java.lang.Object message,
                                                   java.lang.String title,
                                                   int messageType)

  Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display
    `title` - the String to display in the dialog title bar
    `messageType` - the type of message that is to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.

### showInputDialog

    public static java.lang.Object showInputDialog(java.awt.Component parentComponent,
                                                   java.lang.Object message,
                                                   java.lang.String title,
                                                   int messageType,
                                                   Icon icon,
                                                   java.lang.Object[] selectionValues,
                                                   java.lang.Object initialSelectionValue)

  Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where null implies the user can input whatever they wish, usually by means of a JTextField. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a JComboBox, JList, or JTextField will be used.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display
    `title` - the String to display in the dialog title bar
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the Icon image to display
    `selectionValues` - an array of Objects that gives the possible selections
    `initialSelectionValue` - the value used to initialize the input field
  Returns:
    users input, or null meaning the user canceled the input

### showMessageDialog

    public static void showMessageDialog(java.awt.Component parentComponent,
                                         java.lang.Object message)

  Brings up a confirmation dialog -- a modal information-message dialog titled "Confirm".
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display

### showMessageDialog

    public static void showMessageDialog(java.awt.Component parentComponent,
                                         java.lang.Object message,
                                         java.lang.String title,
                                         int messageType)

  Brings up a dialog that displays a message using a default icon determined by the messageType parameter.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.

### showMessageDialog

    public static void showMessageDialog(java.awt.Component parentComponent,
                                         java.lang.Object message,
                                         java.lang.String title,
                                         int messageType,
                                         Icon icon)

  Brings up a dialog displaying a message, specifying all parameters.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - an icon to display in the dialog that helps the user identify the kind of message that is being displayed.

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message)

  Brings up a modal dialog with the options Yes, No and Cancel; with the title, "Select an Option".
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
  Returns:
    an int indicating the option selected by the user

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType)

  Brings up a modal dialog where the number of choices is determined by the `optionType` parameter.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
  Returns:
    an int indicating the option selected by the user

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType,
                                        int messageType)

  Brings up a modal dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
  Returns:
    an int indicating the option selected by the user

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType,
                                        int messageType,
                                        Icon icon)

  Brings up a modal dialog with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the icon to display in the dialog
  Returns:
    an int indicating the option selected by the user

### showOptionDialog

    public static int showOptionDialog(java.awt.Component parentComponent,
                                       java.lang.Object message,
                                       java.lang.String title,
                                       int optionType,
                                       int messageType,
                                       Icon icon,
                                       java.lang.Object[] options,
                                       java.lang.Object initialValue)

  Brings up a modal dialog with a specified icon, where the initial choice is dermined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

  If `optionType` is YES_NO_OPTION, or YES_NO_CANCEL_OPTION and the `options` parameter is null, then the options are supplied by the look and feel.

  The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the icon to display in the dialog
    `options` - an array of objects indicating the possible choices the user can make. If the objects are components, they are rendered properly. Non-String objects are rendered using their `toString` methods. If this parameter is null, the options are determined by the look and feel.
    `initialValue` - the object that represents the default selection for the dialog
  Returns:
    an int indicating the option chosen by the user, or CLOSED_OPTION if the user closed the Dialog

### createDialog

    public JDialog createDialog(java.awt.Component parentComponent,
                                java.lang.String title)

  Creates and returns a new JDialog wrapping `this` centered on the `parentComponent` in the `parentComponent`'s frame. `title` is the title of the returned dialog. The returned JDialog will be set up such that once it is closed, or the user clicks on the OK button, the dialog will be disposed and closed. Re if the parentComponent has no Frame, a default Frame is used.
  Parameters:
    `title` - the title string for the dialog
  Returns:
    a new JDialog containing this instance

### showInternalMessageDialog

    public static void showInternalMessageDialog(java.awt.Component parentComponent,
                                                 java.lang.Object message)

  Brings up an internal confirmation dialog panel. The dialog is a modal information-message dialog titled "Message".
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The object to display

### showInternalMessageDialog

    public static void showInternalMessageDialog(java.awt.Component parentComponent,
                                                 java.lang.Object message,
                                                 java.lang.String title,
                                                 int messageType)

  Brings up an internal dialog panel that displays a message using a default icon determined by the messageType parameter.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.

### showInternalMessageDialog

    public static void showInternalMessageDialog(java.awt.Component parentComponent,
                                                 java.lang.Object message,
                                                 java.lang.String title,
                                                 int messageType,
                                                 Icon icon)

  Brings up an internal dialog panel displaying a message, specifying all parameters.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
    `title` - the title string for the dialog
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - an icon to display in the dialog that helps the user identify the kind of message that is being displayed.

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message)

  Brings up an internal dialog panel with the options Yes, No and Cancel; with the title, "Select an Option".
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The Object to display
  Returns:
    an int indicating the option selected by the user

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType)

  Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The object to display in the dialog. A Component object is rendered as a Component. A String object is rendered as a string. Other objects are converted to a String using the `toString` method.
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
  Returns:
    an int indicating the option selected by the user

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType,
                                                int messageType)

  Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The object to display in the dialog. A Component object is rendered as a Component. A String object is rendered as a string. Other objects are converted to a String using the `toString` method.
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
  Returns:
    an int indicating the option selected by the user

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType,
                                                int messageType,
                                                Icon icon)

  Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The object to display in the dialog. A Component object is rendered as a Component. A String object is rendered as a string. Other objects are converted to a String using the `toString` method.
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the icon to display in the dialog
  Returns:
    an int indicating the option selected by the user

### showInternalOptionDialog

    public static int showInternalOptionDialog(java.awt.Component parentComponent,
                                               java.lang.Object message,
                                               java.lang.String title,
                                               int optionType,
                                               int messageType,
                                               Icon icon,
                                               java.lang.Object[] options,
                                               java.lang.Object initialValue)

  Brings up an internal dialog panel with a specified icon, where the initial choice is dermined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

  If `optionType` is YES_NO_OPTION, or YES_NO_CANCEL_OPTION and the `options` parameter is null, then the options are supplied by the look and feel.

  The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - Determines the Frame in which the dialog is displayed. If null, or if the parentComponent has no Frame, a default Frame is used.
    `message` - The object to display in the dialog. A Component object is rendered as a Component. A String object is rendered as a string. Other objects are converted to a String using the `toString` method.
    `title` - the title string for the dialog
    `optionType` - an int designating the options available on the dialog: YES_NO_OPTION, or YES_NO_CANCEL_OPTION
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable look and feel: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the icon to display in the dialog
    `options` - an array of objects indicating the possible choices the user can make. If the objects are components, they are rendered properly. Non-String objects are rendered using their `toString` methods. If this parameter is null, the options are determined by the look and feel.
    `initialValue` - the object that represents the default selection for the dialog
  Returns:
    an int indicating the option chosen by the user, or CLOSED_OPTION if the user closed the Dialog

### showInternalInputDialog

    public static java.lang.String showInternalInputDialog(java.awt.Component parentComponent,
                                                           java.lang.Object message)

  Shows an internal question-message dialog requesting input from the user parented to `parentComponent`. The dialog is displayed in the Component's frame, and is usually positioned below the Component.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display

### showInternalInputDialog

    public static java.lang.String showInternalInputDialog(java.awt.Component parentComponent,
                                                           java.lang.Object message,
                                                           java.lang.String title,
                                                           int messageType)

  Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display
    `title` - the String to display in the dialog title bar
    `messageType` - the type of message that is to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.

### showInternalInputDialog

    public static java.lang.Object showInternalInputDialog(java.awt.Component parentComponent,
                                                           java.lang.Object message,
                                                           java.lang.String title,
                                                           int messageType,
                                                           Icon icon,
                                                           java.lang.Object[] selectionValues,
                                                           java.lang.Object initialSelectionValue)

  Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where null implies the user can input whatever they wish, usually by means of a JTextField. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a JComboBox, JList, or JTextField will be used.
  Parameters:
    `parentComponent` - the parent Component for the dialog
    `message` - the Object to display
    `title` - the String to display in the dialog title bar
    `messageType` - the type of message to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE.
    `icon` - the Icon image to display
    `selectionValues` - an array of Objects that gives the possible selections
    `initialSelectionValue` - the value used to initialize the input field
  Returns:
    users input, or null meaning the user canceled the input

### createInternalFrame

    public JInternalFrame createInternalFrame(java.awt.Component parentComponent,
                                              java.lang.String title)

  Creates and returns an instance of JInternalFrame. The internal frame is created with the specified title, and wrapping the JOptionPane. The returned JInternalFrame is added to the JDesktopPane ancestor of parentComponent, or components parent if one its ancestors isn't a JDesktopPane, or if parentComponent doesn't have a parent then a `RuntimeException` is thrown.
  Parameters:
    `parentComponent` - the parent Component for the internal frame
    `title` - the String to display in the frame's title bar
  Returns:
    a JInternalFrame containing a JOptionPane

### getFrameForComponent

    public static java.awt.Frame getFrameForComponent(java.awt.Component parentComponent)

  Returns the specified component's Frame.
  Parameters:
    `parentComponent` - the Component to check for a Frame
  Returns:
    the Frame that contains the component, or the default frame if the component is null, or does not have a valid Frame parent

### getDesktopPaneForComponent

    public static JDesktopPane getDesktopPaneForComponent(java.awt.Component parentComponent)

  Returns the specified component's desktop pane.
  Parameters:
    `parentComponent` - the Component to check for a desktop
  Returns:
    the JDesktopPane that contains the component, or null if the component is null or does not have an ancestor that is a JInternalFrame

### setRootFrame

    public static void setRootFrame(java.awt.Frame newRootFrame)

  Sets the frame to use for class methods in which a frame is not provided.
  Parameters:
    `newRootFrame` - the default Frame to use

### getRootFrame

    public static java.awt.Frame getRootFrame()

  Returns the Frame to use for the class methods in which a frame is not provided.
  Returns:
    the default Frame to use

### setUI

    public void setUI(OptionPaneUI ui)

  Sets the UI object which implements the L&F for this component.
  Parameters:
    `ui` - the OptionPaneUI L&F object
  See Also:
    `UIDefaults.getUI(javax.swing.JComponent)`

### getUI

    public OptionPaneUI getUI()

  Returns the UI object which implements the L&F for this component.
  Returns:
    the OptionPaneUI object

### updateUI

    public void updateUI()

  Notification from the UIManager that the L&F has changed. Replaces the current UI object with the latest version from the UIManager.
  Overrides:
    updateUI in class JComponent
  See Also:
    `JComponent.updateUI()`

### getUIClassID

    public java.lang.String getUIClassID()

  Returns the name of the UI class that implements the L&F for this component.
  Returns:
    "OptionPaneUI"
  Overrides:
    getUIClassID in class JComponent
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### setMessage

    public void setMessage(java.lang.Object newMessage)

  Sets the option pane's message-object.
  Parameters:
    `newMessage` - the Object to display
  See Also:
    `getMessage()`

### getMessage

    public java.lang.Object getMessage()

  Returns the message-object this pane displays.
  Returns:
    the Object that is displayed
  See Also:
    `setMessage(java.lang.Object)`

### setIcon

    public void setIcon(Icon newIcon)

  Sets the icon to display. If non-null, the look and feel does not provide an icon.
  Parameters:
    `icon` - the Icon to display
  See Also:
    `getIcon()`

### getIcon

    public Icon getIcon()

  Returns the icon this pane displays.
  Returns:
    the Icon that is displayed
  See Also:
    `setIcon(javax.swing.Icon)`

### setValue

    public void setValue(java.lang.Object newValue)

  Sets the value the user has chosen.
  Parameters:
    `newValue` - the chosen value
  See Also:
    `getValue()`

### getValue

    public java.lang.Object getValue()

  Returns the value the user has selected. UNINITIALIZED_VALUE implies the user has not yet made a choice, null means the user closed the window with out chosing anything. Otherwise the returned value will be one of the options defined in this object.
  Returns:
    the Object chosen by the user, UNINITIALIZED_VALUE if the user has not yet made a choice, or null if the user closed the window without making a choice.
  See Also:
    `setValue(java.lang.Object)`

### setOptions

    public void setOptions(java.lang.Object[] newOptions)

  Sets the options this pane displays. If an element in newOptions is a Comonent it is added directly to the pane, Otherwise a button is created for the element.
  Parameters:
    `newOptions` - an array of Objects that create the buttons the user can click on, or arbitrary Components to add to the pane
  See Also:
    `getOptions()`

### getOptions

    public java.lang.Object[] getOptions()

  Returns the choices the user can make.
  Parameters:
    `the` - array of Objects that give the user's choices
  See Also:
    `setOptions(java.lang.Object[])`

### setInitialValue

    public void setInitialValue(java.lang.Object newInitialValue)

  Sets the initial value that is to be enabled -- the Component that has the focus when the pane is initially displayed.
  Parameters:
    `newInitialValue` - the Object that gets the initial keyboard focus
  See Also:
    `getInitialValue()`

### getInitialValue

    public java.lang.Object getInitialValue()

  Returns the initial value.
  Returns:
    the Object that gets the initial keyboard focus
  See Also:
    `setInitialValue(java.lang.Object)`

### setMessageType

    public void setMessageType(int newType)

  Sets the option pane's message type. The message type is used by the look and feel to determine the icon to display (if not supplied) as well as potentially how to lay out the parentComponent.
  Parameters:
    `newType` - an int specifying the kind of message to display: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE. Otherwise, a RuntimeEception is thrown.
  See Also:
    `getMessageType()`

### getMessageType

    public int getMessageType()

  Returns the message type.
  Returns:
    an int specifying the message type
  See Also:
    `setMessageType(int)`

### setOptionType

    public void setOptionType(int newType)

  Sets the options to display. The option type is used by the look and feel to determine what buttons to show (unless options are supplied).
  Parameters:
    `newType` - an int specifying the options the L&F is to display: DEFAULT_OPTION, YES_NO_OPTION, YES_NO_CANCEL_OPTION, or OK_CANCEL_OPTION. Otherwise, a RuntimeException is thrown.
  See Also:
    `getOptionType()`, `setOptions(java.lang.Object[])`

### getOptionType

    public int getOptionType()

  Returns the type of options that are displayed.
  Returns:
    an int specifying the user-selectable options
  See Also:
    `setOptionType(int)`

### setSelectionValues

    public void setSelectionValues(java.lang.Object[] newValues)

  Sets the selection values for a pane that provides the user with a list of items to choose from. (The UI provides a widget for choosing one of the values.)

  Sets `wantsInput` to true. Use `setInitialSelectionValue` to specify the initially-chosen value. After the pane as been enabled, inputValue is set to the value the user has selected.

  Parameters:
    `newValues` - an array of Objects the user to be displayed (usually in a list or combo-box) from which the user can make a selection
  See Also:
    `setWantsInput(boolean)`, `setInitialSelectionValue(java.lang.Object)`, `getSelectionValues()`

### getSelectionValues

    public java.lang.Object[] getSelectionValues()

  Returns the selection values.
  Parameters:
    `return` - the array of Objects the user can select
  See Also:
    `setSelectionValues(java.lang.Object[])`

### setInitialSelectionValue

    public void setInitialSelectionValue(java.lang.Object newValue)

  Sets the initial selection value. Only used if `wantsInput` is true.
  Parameters:
    `newValue` - the initially selected value
  See Also:
    `setSelectionValues(java.lang.Object[])`, `getInitialSelectionValue()`

### getInitialSelectionValue

    public java.lang.Object getInitialSelectionValue()

  Returns the initial-selection value..
  Returns:
    the initially selected value
  See Also:
    `setInitialSelectionValue(java.lang.Object)`, `setSelectionValues(java.lang.Object[])`

### setInputValue

    public void setInputValue(java.lang.Object newValue)

  Sets the user's input-value.
  Parameters:
    `newValue` - the Object used to initialized the value that the user specified (usually in a text field)
  See Also:
    `setSelectionValues(java.lang.Object[])`, `setWantsInput(boolean)`, `getInputValue()`

### getInputValue

    public java.lang.Object getInputValue()

  Returns the value the user has input, if `wantsInput` is true.
  Returns:
    the Object the user specified, if it was one of the objects, or a String if it was a value typed into a field.
  See Also:
    `setSelectionValues(java.lang.Object[])`, `setWantsInput(boolean)`, `setInputValue(java.lang.Object)`

### getMaxCharactersPerLineCount

    public int getMaxCharactersPerLineCount()

  Returns the maximum number of characters to place on a line in a message. Default is to return Integer.MAX_VALUE. The value can be changed by overriding this method in a subclasse.
  Returns:
    an int giving the maximum number of characters on a line

### setWantsInput

    public void setWantsInput(boolean newValue)

  If `newValue` is true, a parentComponent is provided to allow the user to input a value. If `getSelectionValues` returns a non-null the input value is one of the objects in that array. Otherwise the input value is whatever the user inputs.

  This is a bound property.

  See Also:
    `setSelectionValues(java.lang.Object[])`, `setInputValue(java.lang.Object)`

### getWantsInput

    public boolean getWantsInput()

  Returns true if a parentComponent will be provided for the user to input.
  Returns:
    true if a parentComponent will be provided
  See Also:
    `setWantsInput(boolean)`

### selectInitialValue

    public void selectInitialValue()

  Requests that the initial value be selected, which will set focus to the initial value. This method should be invoked after the window containing the option pane is made visible.

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JOptionPane. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JOptionPane.
  Overrides:
    paramString in class JComponent

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JComponent
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JComponent
  Overrides:
    getAccessibleContext in class JComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.